function [ debug ] = processDebugData( logData, sampleTimes )
%PROCESSDEBUGDATA Summary of this function goes here
%   Detailed explanation goes here

numSamples = length(sampleTimes);
[debug.time.fusion, debug.time.ctrl] = procDebugTime();

function [fusionTime, ctrlTime] = procDebugTime()
	firstCol = find(strcmp(logData.ctrl_tigga_debug.names, 'fusion_time'));

	timeData = logData.ctrl_tigga_debug.data(:,[1 firstCol firstCol+1]);

	ctrlTime = zeros(numSamples, 1);
	fusionTime = zeros(numSamples, 1);
    
	[~, ia] = unique(timeData(:,1));	% find unqiue entries
	timeData = timeData(ia, :);	% delete duplicates
    
    if length(timeData) < 10
        return;
    end

	fusionTime(:,1) = interp1(timeData(:,1), timeData(:,2), sampleTimes);
	ctrlTime(:,1) = interp1(timeData(:,1), timeData(:,3), sampleTimes);
end

end
